##parameters=item=None, brain=None, dodateiso=0, modify_brain_url=1, mcat=None, prefered_keys=None

# This script must deal with real objects and with brains

if item is None and brain is None:
    item = context.this()

if mcat is None:
    mcat = context.portal_messages

if item is not None:
    wftool = context.portal_workflow

    id = item.getId()
    url = item.absolute_url()
    folderish = getattr(item, 'isPrincipiaFolderish', 0)
    contentish = getattr(item, 'isPortalContent', 0)

    try: ricon = item.getIcon(relative_to_portal=1)
    except AttributeError: ricon = ''
    if not ricon:
        ricon = getattr(item, 'icon', '')
        if callable(ricon):
            ricon = ricon()

    try: typ = item.Type()
    except AttributeError: typ = ''

    try: portal_typ = item.portal_type
    except AttributeError: portal_typ = ''

    try:
        title = item.Title()
        title = mcat(title)
    except AttributeError:
        title = ''

    try: description = item.Description()
    except AttributeError: description = ''

    try: moddate = item.ModificationDate()
    except AttributeError: moddate = None

    try: creadate = item.CreationDate()
    except AttributeError: creadate = None

    try: isdocumentcontainer = item.isDocumentContainer
    except: isdocumentcontainer = 0

    public_categories = wftool.getInfoFor(item, 'PublicCategories', None)
    pending_categories = wftool.getInfoFor(item, 'PendingCategories', None)
    review_state = wftool.getInfoFor(item, 'review_state', None)
    version_state = wftool.getInfoFor(item, 'version_state', None)
    schema_name = wftool.getInfoFor(item, 'schema_name', None)
    schema_state = wftool.getInfoFor(item, 'schema_state', None)
    schema_action = wftool.getInfoFor(item, 'schema_action', None)
    schema_actor = wftool.getInfoFor(item, 'schema_actor', None)
    schema_time = wftool.getInfoFor(item, 'schema_time', None)

    if dodateiso: # for explicit date in item
        dateiso = item.dateiso

else:
    id = brain.id
    url = brain.getURL()
    folderish = brain.isPrincipiaFolderish
    contentish = brain.isPortalContent
    isdocumentcontainer = 0 # XXX fix me
    ricon = brain.getIconRelative # relative to portal
    typ = brain.Type
    portal_typ = brain.portal_type
    title = brain.Title
    title = mcat(str(title))
    description = brain.Description
    creadate = brain.CreationDate
    moddate = brain.ModificationDate
    public_categories = brain.PublicCategories
    pending_categories = brain.PendingCategories
    review_state = brain.review_state
    version_state = 'stable'
    schema_name = '' # XXX do we care about it for brain access ?
    schema_state = ''
    schema_action = ''
    schema_actor = ''
    schema_time = ''
    if dodateiso: # for explicit date in item
        dateiso = brain.dateiso


if contentish:
    action = 'view'
elif portal_typ == 'Reviewed Hierarchy Level':
    action = 'folder_contents'
else:
    action = ''
date_format = mcat('_date_%m/%d/%Y %H:%M')
if title:
    thetitle = title
else:
    thetitle = '%s (%s)' % (id, mcat('_(document)_Untitled_'))
if moddate:
    modification = DateTime(moddate).strftime(date_format)
else:
    moddate = ''
    modification = ''

if creadate:
    creation = DateTime(creadate).strftime(date_format)
else:
    creadate = ''
    creation = ''

if public_categories or pending_categories:
    hier = context.portal_hierarchies.main
    hierkeydict = hier.getHierarchyKeyDict()
    pubs = []
    if modify_brain_url and brain is not None:
        prefered_keys = prefered_keys or context.getSubHierarchiesKeys()
        proposed_keys = [key for key in prefered_keys if key in public_categories]
        if proposed_keys:
            key_modifier = proposed_keys[0]
        elif public_categories:
            key_modifier = public_categories[0]
        else: # XXX else what? pending categories?
            key_modifier = None
    else:
        key_modifier = None
        
    for key in public_categories:
        dict = hierkeydict.get(key, None)
        if dict is not None:
            hier_title = dict['title']
            hier_title = mcat(hier_title)
            pubs.append(hier_title)
            if key_modifier and key == key_modifier:
                url = dict['rurl'] + '/' + id
                url = context.portal_url() + url
    public_categories_string = string.join(pubs, ', ')
    pends = []
    for key in pending_categories:
        dict = hierkeydict.get(key, None)
        if dict is not None:
            hier_title = dict['title']
            hier_title = mcat(hier_title)
            pends.append(hier_title)
    pending_categories_string = string.join(pends, ', ')
else:
    public_categories_string = ''
    pending_categories_string = ''

portal_url = context.portal_url(relative=1)
if portal_url: portal_url = '/'+portal_url
if ricon:
    icon = portal_url + '/' + ricon
else:
    icon = ''

schema_state_name = ''
schema_action_name = '' # XXX not set
if schema_name:
    if schema_state:
        schema = getattr(context.portal_workflow_schema, schema_name, None)
        if schema is not None:
            state = getattr(schema, schema_state, None)
            if state is not None:
                schema_state_name = state.title
    if schema_action:
        pass

schema_time_ago = ''
if schema_time:
    now = DateTime()
    then = DateTime(schema_time)
    secs = int(now) - int(then)
    mins = secs/60
    hours = mins/60
    days = hours/24
    if mins < 60:
        if mins>=2:
            schema_time_ago = mcat('_%s minutes (plural)_') % (mins, )
        else:
            schema_time_ago = mcat('_%s minute (single)_') % (mins, )
    elif hours < 24:
        if hours>=2:
            schema_time_ago = mcat('_%s hours (plural)_') % (hours, )
        else:
            schema_time_ago = mcat('_%s hour (single)_') % (hours, )
    else:
        if days>=2:
            schema_time_ago = mcat('_%s days (plural)_') % (days, )
        else:
            schema_time_ago = mcat('_%s day (single)_') % (days, )
        
d = {
    'item': item,
    'brain': brain,
    'id': id,
    'isup': 0, # caller should change this if needed
    'url': url,
    'icon': icon,
    'action': action,
    'type': typ,
    'portal_type': portal_typ,
    'folderish': not not folderish,
    'contentish': not not contentish,
    'title': thetitle,
    'description': description,
    'creadate': creadate,
    'creation': creation,
    'moddate': moddate,
    'modification': modification,
    'public_categories': public_categories,
    'pending_categories': pending_categories,
    'public_categories_string': public_categories_string,
    'pending_categories_string': pending_categories_string,
    'review_state': review_state,
    'version_state': version_state,
    'schema_name': schema_name,
    'schema_state': schema_state,
    'schema_state_name': schema_state_name,
    'schema_action': schema_action,
    'schema_actor': schema_actor,
    'schema_time': schema_time,
    'schema_time_ago': schema_time_ago,
    # 'nocheck'
}

if dodateiso:
    d['dateiso'] = dateiso

return d
