##parameters=where=None, current_action=None, page=None, REQUEST=None, **kw

portal = context.portal_url.getPortalObject()
try:
    helpdir = portal.Help
except AttributeError:
    return 'Help files not installed.'

try:
    portal_type = context.portal_type or ''
except AttributeError:
    portal_type = ''


info = {
    'pg': page or '__NoPageProvided__',
    'pt': portal_type.replace(' ', '_'),
    'w': where or '__NoWhereProvided__',
    'a': current_action,
    }

tries = (
    'help_%(pg)s' % info,
    'help_%(pt)s_%(a)s' % info,
    'help_%(pt)s' % info,
    'help_%(w)s' % info,
    )

doc = None
for name in tries:
    doc = getattr(helpdir, name, None)
    if doc is not None:
        break

if doc is None:
    try:
        doc = helpdir.help_portal
    except AttributeError:
        return 'Default help file not installed.'

return doc.CookedBody(stx_level=1)
