# Copyright (c) 2002-2003 Nuxeo SARL <http://nuxeo.com>
# Copyright (c) 2002 Prfecture du Bas-Rhin, France
# Copyright (c) 2002 CIRB, Belgique
# Authors: Florent Guillaume <mailto:fg@nuxeo.com>
#          Julien Jalon <mailto:jj@nuxeo.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: cpsdocument_utils.py,v 1.5 2003/04/01 21:53:58 fermigier Exp $

from OFS.Image import Image

def getImageForFile(**kw):
    """getImageForFile(theid=file) will create an OFS.Image object
    with id=='theid'.

    Returns None if the file is (somehow) empty.
    """
    id = kw.keys()[0]
    file = kw[id]
    if not file:
        return None
    image = Image(id, title=id, file=file)
    if not image.get_size():
        return None
    else:
        return image

