# (c) 2002 Nuxeo SARL <http://nuxeo.com>
# (c) 2002 Florent Guillaume <mailto:fg@nuxeo.com>
# (c) 2002 Prfecture du Bas-Rhin, France
# See license info at the end of this file.
# $Id: __init__.py,v 1.4 2002/09/05 13:39:35 jalon Exp $

import sys

from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.CMFCorePermissions import AddPortalContent


import Workgroup


contentClasses = (Workgroup.Workgroup,)
contentConstructors = (Workgroup.addWorkgroup,)
fti = (Workgroup.factory_type_information)
bases = contentClasses

this_module = sys.modules[__name__]
z_bases = utils.initializeBasesPhase1(bases, this_module)

registerDirectory('skins', globals())

def initialize(registrar):
    utils.initializeBasesPhase2(z_bases, registrar)
    utils.ContentInit(
        'Workgroup',
        content_types = contentClasses,
        permission = AddPortalContent, # XXX
        extra_constructors = contentConstructors,
        fti = fti,
        ).initialize(registrar)
    # icon
    utils.registerIcon(Workgroup.Workgroup, 'workgroup_icon.gif', globals())


# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
